您的位置:首页 > 其它

HDU4283-You Are the One

2016-09-18 21:20 267 查看


You Are the One

                                                                       Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768
K (Java/Others)

                                                                                                  Total Submission(s): 3389    Accepted Submission(s): 1546


Problem Description

  The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At
the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for
(k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to
leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?

 

Input

  The first line contains a single integer T, the number of test cases.  For each case, the first line is n (0 < n <= 100)

  The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)

 

Output

  For each test case, output the least summary of unhappiness .

 

Sample Input

2
  
5
1
2
3
4
5

5
5
4
3
2
2

 

Sample Output

Case #1: 20
Case #2: 24

 

Source

2012 ACM/ICPC Asia Regional Tianjin Online

题意:有一群屌丝,每个屌丝有个屌丝值,如果他第K个上场,屌丝值就为a[i]*(k-1),同过一个小黑屋来调整,是的最后总屌丝值最小

解题思路:dp[i][j]表示从第i个人到第j个人这段区间的最小花费(是只考虑这j-i+1个人,不需要考虑前面有多少人)那么对于dp[i][j]的第i个人,就有可能第1个上场,也可以第j-i+1个上场。考虑第i个人第K个上场 即在i+1之后的K-1个人是率先上场的,dp[i+1][i+k-1]表示在第i个人之前上场的 对于第i个人,由于是第k个上场的,那么屌丝值便是a[i]*(k-1),其余的人是排在第k+1个之后出场的,也就是dp[i+k][j],对于这个区间的人,由于排在第k+1个之后,所以整体愤怒值要加上k*(sum[j]-sum[i+k-1]) 

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <queue>
#include <stack>

using namespace std;

const int MAXN=120;
const int INF=0x3f3f3f3f;
int a[MAXN];
int sum[MAXN];
int dp[MAXN][MAXN];

int main()
{
int t,n;
int cas=0;
scanf("%d",&t);
while(t--)
{
scanf("%d",&n);
sum[0]=0;
for(int i=1; i<=n; i++)
{
scanf("%d",&a[i]);
sum[i]=sum[i-1]+a[i];
}
memset(dp,0,sizeof dp);
for(int i=1; i<=n; i++)
for(int j=i+1; j<=n; j++)
dp[i][j]=INF;
for(int len=1; len<n; len++)
{
for(int i=1; i+len<=n; i++)
{
int j=i+len;
for(int k=1; k<=j-i+1; k++)
dp[i][j]=min(dp[i][j],dp[i+1][i+k-1]+dp[i+k][j]+k*(sum[j]-sum[i+k-1])+a[i]*(k-1));
}
}
printf("Case #%d: %d\n",++cas,dp[1]
);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: